/*
Scrivere un programma per la gestione degli acquisti online. 
Ogni acquisto  caratterizzato dalle seguenti informazioni: 
codice prodotto (numero intero), prezzo prodotto, codice transazione (esempio N3G8A273), data delloperazione.
Gli acquisti sono organizzati in memoria come una vettore di 50 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di un nuovo acquisto;
2)Visualizzazione degli acquisti relativi a un certo giorno (chiedere la data dellacquisto);
3) Ordinamento rispetto al codice prodotto degli acquisti;
4) Salvataggio su file.
Allavvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore.


*/

#include<stdio.h>
#include<string.h>

struct acquisto{
       int codice_prodotto;
       float prezzo_prodotto;
       char codice_transazione[20];
       char data_operazione[12];
       };
       
void menu();
void inserimento (struct acquisto *A, int *pn);
void visualizza (struct acquisto *A, int n); 
void ordinamento (struct acquisto *A, int n);
void salva (struct acquisto *A, int n);
void inizializza (struct acquisto *A, int *pn); 

main()
{
      int scelta;
      int n;
      struct acquisto P[50];
      
      
      inizializza(P,&n);
      
      do{
            menu();
            scanf("%d",&scelta);
            
            switch (scelta){
                   
                   case 1: inserimento(P,&n);
                         break;
                   
                   case 2: visualizza(P,n);
                         break;
                   
                   case 3: ordinamento(P,n);
                         break;
                   
                   case 4: salva(P,n);
                         break;
                   
                   case 0: printf("\n\t\t***FINE ESECUZIONE***\n");
                         break;
                   
                   default:printf("\nTasto digitato non valido!\n");
                   }
            }while(scelta!=0);
      getch();
}


   void menu()
   {
        printf("\nPROGRAMMA PER LA GESTIONE DEGLI ACQUISTI ONLINE\n");
        printf("\n\t\t***MENU'***\n");
        
        printf("\nDigitare 1) per inserire un nuovo acquisto\n");
        printf("Digitare 2) per visualizzare gli acquisti relativi a un giorno specifico\n");
        printf("Digitare 3) per ordinare gli acquisti rispetto al codice prodotto\n");
        printf("Digitare 4) per salvare su file\n");
        printf("Digitare 0) per terminare l'esecuzione del programma\n");
        
   }
   
   void inserimento (struct acquisto *A, int *pn)
   {
        struct acquisto T;
        
        printf("\n\t\t***INSERIMENTO***\n");
        
        if(*pn<50)
        {
           printf("\nInserire il codice del prodotto:\n");
           scanf("%d",&T.codice_prodotto);
           printf("Inserire il prezzo del prodotto:\n");
           scanf("%f",&T.prezzo_prodotto);
           printf("Inserire il codice di transazione:\n");
           scanf("%s",T.codice_transazione);
           printf("Inserire la data dell'operazione (gg/mm/aa):\n");
           scanf("%s",T.data_operazione);
           A[*pn]=T;
           (*pn)++;
        }
        else printf("\nImpossibile inserire acquisti, non c'e' piu' spazio disponibile!\n");
  }

  void visualizza (struct acquisto *A, int n)
  {
       char data[12];
       int i;
       
       
       printf("\n\t\t***VISUALIZZAZIONE***\n");
       
       printf("\nInserire la data per visualizzare gli acqusiti (gg/mm/aa):\n");
       scanf("%s",data);
       
       for (i=0;i<n;i++)
          if(strcmp(A[i].data_operazione,data)==0)
          {
             printf("\nCodice prodotto: %d\n",A[i].codice_prodotto);
             printf("Prezzo: %f\n",A[i].prezzo_prodotto);
             printf("Codice transazione: %s\n",A[i].codice_transazione);
          }
  }

  void ordinamento (struct acquisto *A, int n)
  {
       int sup;
       int i;
       struct acquisto temp;
       
       
        printf("\n\t\t***ORDINAMENTO***\n");
                
        for(sup=n-1;sup>0;sup--)
           for(i=0;i<sup;i++)
              if(A[i].codice_prodotto>A[i+1].codice_prodotto)
              { 
                 temp=A[i];
                 A[i]=A[i+1];
                 A[i+1]=temp; 
                
              } 
              
  }

  void salva (struct acquisto *A, int n)
  {
       FILE *pf;
       int i;
       
       printf("\n\t\t***SALVA SU FILE***\n");
       
       pf=fopen("acquisto.dat","wb");
       
       if(pf!=NULL)
       {
          for (i=0;i<n;i++)
             fwrite(&A[i],sizeof (struct acquisto),1,pf);
          fclose(pf);
       }
       else printf("\nERRORE IN SCRITTURA!\n");
  }

  void inizializza (struct acquisto *A, int *pn)
  {
       FILE *pf;
       int i;
       struct acquisto T;
       
       i=0;
       
       pf=fopen("acquisto.dat","rb");
       
       if(pf!=NULL)
       {
          while(i<50 && fread(&T,sizeof (struct acquisto),1,pf)>0)
          {
             A[i]=T;
             i++;
          }
         fclose(pf);
       }
       else printf("\nERRORE IN LETTURA!\n");
       *pn=i;
  }
